      SUBROUTINE OUTLINES

	  USE WINTERACTER 
      USE BLK1MOD
      include 'd.inc'
!      INCLUDE 'BLK1.COM' 

!      INTEGER*2 MSN 
!      COMMON /MID/ MSN(MAXP) 

      CHARACTER(LEN=255)  :: FNAME,FILTER
      CHARACTER(LEN=4)    :: SUB
	  LOGICAL OPENED
      CHARACTER*1  IFLAG,ANS(10)
      DATA ANS/' ',' ',' ',' ',' ',' ','n','z','r','q'/ 

      IF(.NOT. ALLOCATED(ICONNCT)) THEN
        ALLOCATE (ICONNCT(MAXP,2),IOUTLST(10,5000),NOUTLST(10))
      ENDIF
      IF(.NOT. ALLOCATED(XOUT)) THEN
        ALLOCATE (XOUT(5000,10),YOUT(5000,10))
      ENDIF
      
      IOUTOUT=26
      INQUIRE(26, OPENED=OPENED)
      if(.not. opened) then
        Filter='OUTLINE file  -- *.dat|*.dat|POLY file  -- *.poly|*.poly|'

        CALL WSelectFile(Filter,SaveDialog+PromptOn+AppendExt+DirChange,FNAME,'Save Outline File')
 
        IF (WInfoDialog(ExitButtonCommon).EQ.CommonOpen) THEN

   	      CALL IlowerCase(FNAME)
	      CALL GETSUB(FNAME,SUB)
          OPEN(IOUTOUT,FILE=FNAME,STATUS='UNKNOWN',ACTION='WRITE')
        ELSE
          GO TO 1
        ENDIF
      ENDIF

    1 CONTINUE

      call wdialogload(IDD_DIALOG08)
      ierr=infoerror(1)


      call wdialogputRadioButton(idf_radio1)


      CALL WDialogSelect(IDD_DIALOG08)
      ierr=infoerror(1)
 
      CALL WDialogShow(-1,-1,0,Modal)
      ierr=infoerror(1)
      

      do
         IF (WInfoDialog(ExitButton) .EQ. IDOK) THEN

          call wdialoggetradiobutton(idf_radio1,ipos)
          ipos=3-ipos
          go to 50
         endif
         ipos= 0
         go to 50
      enddo
      ipos= 2
   50 continue
      IF(SUB(1:3) .EQ. 'dat') THEN
	    IOUTSW=0
	  ELSE
	    IOUTSW=1
	  ENDIF
!
!    FORM LIST OF ELEMENT SIDES THAT ARE ON THE OUTSIDE

       DO N=1,NP
	     MSN(N)=0
	   ENDDO
       DO N=1,NE
	     IF(IMAT(N) .NE. 999  .AND.  NCORN(N) .GT. 5  .AND.  (IMAT(N) .LT. 900  .OR. IMAT(N) .GT. 903)) THEN 
	       NCN=NCORN(N)
           DO  K=2,NCN,2 
             J = NOP(N,K)
             if(J .gt. 0) then 
               MSN(J) = MSN(J) + 1 
               ICONNCT(J,1)=NOP(N,K-1)
			   IF(K .EQ. NCN) THEN
			     ICONNCT(J,2)=NOP(N,1)
			   ELSE
   			     ICONNCT(J,2)=NOP(N,K+1)
               ENDIF
             endif
           ENDDO
		 ENDIF
	   ENDDO

!    WORK THROUGH OUTSIDE NODES FORMING UP TO 10 CONTIUOUS SEQUENCES

       DO K=1,10
	     JJ=0
	     DO J=1,NP
		   IF(MSN(J) .EQ. 1) THEN
!
!   THIS IS A STARTING POINT EXTRACT A CORNER NODE
             IOUTLST(K,1)=ICONNCT(J,1)
			 if(ipos .eq. 1) then
               IOUTLST(K,2)=ICONNCT(J,2)
			   JJ=2
			 else
               IOUTLST(K,2)=J
               IOUTLST(K,3)=ICONNCT(J,2)
		  	   JJ=3
			 endif
			 MSN(J)=0
             ICONNCT(J,1)=0
             ICONNCT(J,2)=0

!   NOW LOOK FOR A CONNECTION TO ICONNCT(J,2)
           
  100        CONTINUE
             DO L=1,NP
			  IF(MSN(L) .EQ. 1) THEN
			   IF(ICONNCT(L,1) .EQ. IOUTLST(K,JJ)) THEN

!   FOUND ONE

                 if(ipos .eq. 2) then
                   IOUTLST(K,JJ+1)=ICONNCT(L,2)
                   JJ=JJ+1
				 else
                   IOUTLST(K,JJ+1)=L
                   IOUTLST(K,JJ+2)=ICONNCT(L,2)
                   JJ=JJ+2
				 endif
  	  	  	     MSN(L)=0
                 ICONNCT(L,1)=0
				 JTEMP=ICONNCT(L,2)
                 ICONNCT(L,2)=0
				 IF(JTEMP .EQ. IOUTLST(K,1)) GO TO 200
				 GO TO 100
			   ELSEIF(ICONNCT(L,2) .EQ. IOUTLST(K,JJ)) THEN

!   FOUND ONE THE OPPOSITE WAY

                 IOUTLST(K,JJ+1)=L
                 IOUTLST(K,JJ+2)=ICONNCT(L,1)
                 JJ=JJ+2
  	  	  	     MSN(L)=0
				 JTEMP=ICONNCT(L,1)
                 ICONNCT(L,1)=0
                 ICONNCT(L,2)=0
				 IF(JTEMP .EQ. IOUTLST(K,1)) GO TO 200
				 GO TO 100
               ENDIF
		  
			  ENDIF
			 ENDDO
           ENDIF
         ENDDO
		 GO TO 300
  200    CONTINUE
         NOUTLST(K)=JJ
		 IF(JJ .GT. 0) THEN
  	       IF(IOUTSW .EQ. 1) THEN
	         NDIM=2
		     NZERO=0
		     NONE=1
	         WRITE(IOUTOUT,*)NOUTLST(K)-1,NDIM,NZERO,NZERO
		     DO L=1,NOUTLST(K)-1
               WRITE(IOUTOUT,*) L,XUSR(IOUTLST(K,L)),YUSR(IOUTLST(K,L))
		     ENDDO 
		     WRITE(IOUTOUT,*) NOUTLST(K)-1,NZERO
		     DO I=1,NOUTLST(K)-2
		       WRITE(IOUTOUT,*) I,I,I+1
             ENDDO
   		     WRITE(IOUTOUT,*) NOUTLST(K)-1,NOUTLST(K)-1,NONE
		
		     WRITE(IOUTOUT,*) NZERO
  	 	   ELSE
	         DO L=1,NOUTLST(K)
	           XOUT(L,K)=XUSR(IOUTLST(K,L))
	           YOUT(L,K)=YUSR(IOUTLST(K,L))
               WRITE(IOUTOUT,*) XOUT(L,K),YOUT(L,K)
		     ENDDO
	       ENDIF
		 ENDIF
	   ENDDO
  300  CONTINUE
	   RETURN
	   END