      SUBROUTINE REATTACH
    

      USE BLK1MOD
      USE BLK2MOD 

      INTEGER NS1(3),NT1(3)
      CHARACTER*1  IFLAG,ANSW(10) 
      DATA ANSW/' ',' ',' ',' ',' ',' ','n','z','r','q'/ 
    
!   SETUP CONNECTIVITY TABLE    
      CALL KCON(0)
!   SELECT FIRST ELEMENT
10    CONTINUE   
      NHTP=0 
      NMESS=20 
      NBRR=8 
      CALL HEDR
    
      CALL PROX(XC,YC,NE,XX,YY,IELEM,IFLAG,IESKP,IBOX)
      call fillem(ielem)
      IF(IRMAIN .EQ. 1) RETURN 
      IF(IFLAG .EQ. 'c'  .AND. IBOX .GT. 0) THEN 
        IFLAG=ANSW(IBOX) 
      ENDIF 
!                                                                       
      IF(IFLAG .EQ. 'q') THEN 
          RETURN 
      ENDIF
!   GET UNATTACHED NOP
      DO  K=2,NCORN(IELEM),2 
        NSX=NOP(IELEM,K)
        IF(NDELM(NSX) .EQ. 1) THEN
!   FOUND IT    
          NS1(1)=NOP(IELEM,K-1)
          NS1(2)=NSX
          KK=MOD(K,NCORN(IELEM))+1
          NS1(3)=NOP(IELEM,KK)
          GO TO 280  
        ENDIF 
      ENDDO
  280 CONTINUE 
    
!   SELECT NEXT ELEMENT 
      
      CALL PROX(XC,YC,NE,XX,YY,IELEM1,IFLAG,IESKP,IBOX)
      call fillem(ielem1)

!   GET UNNATCHED SIDE
!   FIND AN UNATTACHED SIDE (INDICATE OF TRIANGLE OR QUADRILATERAL)
      DO  K=2,NCORN(IELEM1),2 
        NSX=NOP(IELEM1,K) 
        IF(NDELM(NSX) .EQ. 1) THEN
!   FOUND IT    
          NT1(1)=NOP(IELEM1,K-1)
          NT1(2)=NSX
          KK=MOD(K,NCORN(IELEM1))+1
          NT1(3)=NOP(IELEM1,KK)
          GO TO 300  
        ENDIF 
      ENDDO
300   CONTINUE 
      
!   FORM A NEW ELEMENT ASSIGN TYPE AS INDICATED
      CALL GETELM(J)
      DO K=1,3
        NOP(J,K)=NS1(K)
        NOP(J,K+4)=NT1(K)
      ENDDO
      NOP(J,4)=0
      NOP(J,8)=0
      IMAT(J)=1
      IESKP(J) = 0 
      NCORN(J)=8

!   GO BACK TO LOOK FOR NEW PAIR    
      GO TO 10
    RETURN
    END